/*
	$Id: Test.java 224 2006-06-01 12:08:23Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.DataOutputStream;
import java.io.IOException;

/**
   ƥȤκǾñ̡
*/
public class Test {

    /** ̤¹Ԥξ֡ */
    public static final int UNTESTED = -2;

    /** ¹ξ֡ */
    public static final int RUNNING = -1;

    /** ֡ */
    public static final int SUCCESS = 0;

    /** Ԥ֡ */
    public static final int FAILED = 1;

    /**
       ưŪ󥯡ܥ˼Ԥ֡

       Funnelͭ饤֥򸫼äꡢͭ饤֥Ƥѹ
       ˤʤä硢η̤ˤʤޤ
    */
    public static final int DYNAMIC_LINK = 2;

    /**
       ʥǽλƼԤ֡

       ơեȤʤɤΰ۾ｪλȡˤ륿
       Ȥβǽޤ
    */
    public static final int SIGNAL = 3;

    /**
       곰ξǼԤ֡
    */
    public static final int UNKNOWN = 4;

    /** ƥȤξ֤κǾ */
    public static final int STATUS_MIN = UNTESTED;

    /** ƥȤξ֤κ */
    public static final int STATUS_MAX = UNKNOWN;

    /** ƥȤΥꥹ */
    private TestListener listener;

    /** 饹̾ */
    private String className;

    /** ᥽å̾ */
    private String methodName;

    /** ¹Ԥоݤɤ */
    private boolean selected;

    /**  */
    private int status;

    /**
       ƥȤޤ

       ƥȤϼ¹ԤоݤǤꡢ̤¹Ԥξ֤ˤʤޤ

       @param listener ƥȥեͥ
       @param className 饹̾
       @param methodName ᥽å̾
    */
    public Test(final TestListener listener,
		final String className, final String methodName) {
	this.listener = listener;
	this.className = className;
	this.methodName = methodName;
	this.selected = true;
	this.status = UNTESTED;
    }

    /**
       ƥȤ¹Ԥޤ

       @param out եͥؤνϥȥ꡼
       @throws IOException ϥȥ꡼ؤν񤭹ߤ˼ԤȤ
       ޤ
    */
    public final void invoke(final DataOutputStream out) throws IOException {
	setStatus(RUNNING);
	out.writeInt(0);
	out.writeInt(className.length());
	out.writeBytes(className);
	out.writeInt(methodName.length());
	out.writeBytes(methodName);
	out.flush();
    }

    /**
       ƥȤΥ饹̾ޤ

       @return 饹̾
    */
    public final String getClassName() {
	return className;
    }

    /**
       ƥȤΥ᥽å̾ޤ

       @return ᥽å̾
    */
    public final String getMethodName() {
	return methodName;
    }

    /**
       ƥȤ¹Ԥоݤɤꤷޤ

       @param selected ¹Ԥоݤɤ
    */
    public final void setSelected(final boolean selected) {
	this.selected = selected;
	listener.selectionChanged(this);
    }

    /**
       ƥȤ¹Ԥоݤɤޤ

       @return ¹Ԥоݤɤ
    */
    public final boolean getSelected() {
	return this.selected;
    }

    /**
       ƥȤξ֤ꤷޤ

       @param status ƥȤξ
    */
    public final void setStatus(final int status) {
	this.status = status;
	listener.statusChanged(this);
    }

    /**
       ƥȤξ֤ޤ

       @return ƥȤξ
    */
    public final int getStatus() {
	return this.status;
    }

    /**
       ƥȤξ֤ʸǼޤ

       @return ƥȤξ֤ɽʸ
    */
    public final String getStatusString() {
	return getStatusString(status);
    }

    /**
       ƥȤξ֤ʸǼޤ

       @param s ƥȤξ
       @return ƥȤξ֤ɽʸ
    */
    public static String getStatusString(final int s) {
	switch (s) {
	default:
	    return null;
	case UNTESTED:
	    return "READY";
	case RUNNING:
	    return "RUNNING";
	case SUCCESS:
	    return "OK";
	case FAILED:
	    return "NG";
	case DYNAMIC_LINK:
	    return "LOST";
	case SIGNAL:
	    return "CRASHED";
	}
    }
}
