/*
	$Id: Pool.h 114 2006-03-05 19:22:51Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

#ifndef POOL_H
#define POOL_H

#include "InputStream.h"
#include "OutputStream.h"

struct impl_Pool;
struct impl_Object;

union Pool {
    union {
        struct impl_Object *object;
    } super;
    struct impl_Pool *impl;
} TRANSPARENT_UNION;

union Pool Pool_create(void);
size_t Pool_getSize(union Pool);
void Pool_free(union Pool);
union OutputStream Pool_getOutputStream(union Pool);
union InputStream Pool_getInputStream(union Pool);

#endif /* !POOL_H */
