/*
	$Id: Receiver.java 97 2006-03-01 13:11:45Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.DataInputStream;
import java.io.IOException;
import java.util.concurrent.LinkedBlockingQueue;

/**
   եͥ뤫ץ饤륹åɡ

   եͥȤ³ڤ줿Ȥ򤹤˸Ф뤿ᡢΥåɤ
   ϥȥ꡼फɤ߹⤦ȤƤޤ

   ץ饤ϥ塼¸ޤץ饤ϤΥ塼
   ޤ
*/
public class Receiver extends Thread {

    /** Funnelϥȥ꡼ */
    private DataInputStream in;

    /** ץ饤Υ塼 */
    private LinkedBlockingQueue<byte[]> queue;

    /** åɤΥƥȤȯ㳰Τꥹ */
    private ExceptionListener listener;

    /**
       ץ饤륹åɤޤ

       @param in ϥȥ꡼
       @param listener 㳰ꥹ
    */
    public Receiver(final DataInputStream in,
		    final ExceptionListener listener) {
	this.in = in;
	this.listener = listener;
	queue = new LinkedBlockingQueue<byte[]>();
    }

    /**
       ץ饤ޤ

       ץ饤¸륭塼ξϡǤ褦ˤʤ
       ǥ֥åԤޤ

       @return ץ饤
       @throws InterruptedException ޤ줿Ȥ˥ޤ
    */
    public final byte[] read() throws InterruptedException {
	return queue.take();
    }

    /**
       ץ饤륹åɤ¹Ԥޤ

       ץ饤ϥ塼¸ޤ
    */
    public final void run() {
	for (;;) {
	    try {
		int size = in.readInt();
		byte[] data = new byte[size];
		in.readFully(data);
		queue.put(data);
	    } catch (InterruptedException e) {
	    } catch (IOException e) {
		listener.exceptionCaught(e);
		return;
	    }
	}
    }
}
