/*
	$Id: Stack.h 97 2006-03-01 13:11:45Z syl $

	Copyright (C) 2001 Syllabub
	Maroontress Fast Software.
*/

#ifndef STACK_H
#define STACK_H

#define STACK_ERROR -1
#define STACK_SUCCESS 0

struct StackCell;
struct Stack;

struct Stack *Stack_create(int capacity);
void Stack_free(struct Stack *s);
int Stack_push(struct Stack *s, struct StackCell *c);
struct StackCell *Stack_pop(struct Stack *s);
struct StackCell *Stack_top(struct Stack *s);
int Stack_getSize(struct Stack *s);

#endif /* !STACK_H */
