/*
	$Id: InputStream.h 104 2006-03-02 15:35:08Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

#ifndef INPUTSTREAM_H
#define INPUTSTREAM_H

#include <unistd.h>
#include "tricks.h"

struct impl_Object;
struct impl_InputStream;

union InputStream {
    union {
	struct impl_Object *object;
    } super;
    struct impl_InputStream *impl;
} TRANSPARENT_UNION;

ssize_t InputStream_read(union InputStream, void *, size_t);
int InputStream_readFully(union InputStream, void *, size_t);
int InputStream_close(union InputStream);

#endif /* !INPUTSTREAM_H */
