/*
	$Id: LinkedList.h 115 2006-03-06 01:12:33Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

#ifndef LINKEDLIST_H
#define LINKEDLIST_H

#include "tricks.h"

struct impl_Object;
struct impl_LinkedList;
union ListElement;

union LinkedList {
    union {
        struct impl_Object *object;
    } super;
    struct impl_LinkedList *impl;
} TRANSPARENT_UNION;

union LinkedList LinkedList_create(void);
void LinkedList_free(union LinkedList);
int LinkedList_append(union LinkedList, union ListElement *);
union ListElement * LinkedList_getFirst(union LinkedList);

#endif /* !LINKEDLIST_H */
